#define __cplusplus__
#ifndef __DISTRIB__
#define __DISTRIB__

#include<iostream>
#include<istream>
#include<fstream>
#include<string>
#include<vector>
#include<sstream>
#include <cmath>


#include <Spatial_Data.hpp>

using namespace std;


/*! \class Distribution
 *  \brief A class representing a distribution.
 *  \author Juliette Blanchet
 *  \date    Dec. 2005

*/

class Distribution{
  
protected:
  /// Dimension 
  uint Dim;

	/// true if the distribution doesn't have to be estimated
	bool fix;	

public :
  /// Destructor
  virtual ~Distribution();
	
	void Fix();
  
  /// Get the dimension
  uint Get_D();  
	
  /// Simulate
  virtual void Simulate(vector<double> & X);

  /// Compute the density 
  double Density(vector<double> const &  X);
 	/// Compute the log density 
  virtual double LogDensity(vector<double> const &  X);

  /// Estimate all parameters from the given data and frequencies
  virtual void Estimate(Spatial_Data *spatd, vector<double>  const &  freqs);
  
  /// Read all parameters from a stream
  virtual void Read_Params(istream & is);
  /// Write all parameters to a stream
  virtual void Write_Params(ostream & os);

  /// Number of free parameters
  virtual uint Degrees_Of_Freedom();

	/// info
	virtual void Info();
};


#endif
