#define __cplusplus__
#ifndef __ICMALGO__
#define __ICMALGO__

#include<iostream>
#include<istream>
#include<fstream>
#include<string>
#include<vector>
#include<sstream>
#include <cmath>

#include <HMRF_Algo.hpp>


using namespace std;


/*! \class ICM_Algorithm
 *  \brief A class representing an ICM algorithm.
 *  \author Lemine Abdallahi
 *  \date    Aug. 2005

 Iterated Conditional Modes for an HMRF.

*/

class ICM_Algorithm : public HMRF_Algorithm{
  
  /// ICM restoration result
    
public :

  /// Constructor
  ICM_Algorithm(HMRF *mod, Spatial_Data *spatd);  
  /// Destructor
  ~ICM_Algorithm();

  /// Run for a number of iterations ...
  void Run(uint nbiter);
  
  /// Neighborhood restoration
  void NR();
  /// Compute fuzzy classifcation for point i
  void Compute_fuzzy(uint i,vector<double> &probs);
  
};


#endif
