#define __cplusplus__
#ifndef __MEANFIELDEMALGO__
#define __MEANFIELDEMALGO__

#include<iostream>
#include<istream>
#include<fstream>
#include<string>
#include<vector>
#include<sstream>
#include <cmath>

#include <NREM_Algo.hpp>

using namespace std;


/*! \class Mean_Field_EM
 *  \brief A class representing a mean field EM algorithm.
 *  \author Lemine Abdallahi
 *  \date    Aug. 2005

 Applies to an HMRF model. uses mean-field approximations, With a mean field neighborhood restoration.

*/

class Mean_Field_EM : public NREM_Algorithm{
  
public :

  /// Constructor
  Mean_Field_EM(HMRF *mod, Spatial_Data *spatd );  
  /// Constructor
  Mean_Field_EM(HMRF *mod, Spatial_Data *spatd , uint EMiter); 

  /// Destructor
  ~Mean_Field_EM();

  /// Noise restoration step
  void NR();
  
};


#endif
