#define __cplusplus__
#ifndef __MODALFIELDEMALGO__
#define __MODALFIELDEMALGO__

#include<iostream>
#include<istream>
#include<fstream>
#include<string>
#include<vector>
#include<sstream>
#include <cmath>

#include <NREM_Algo.hpp>

using namespace std;


/*! \class Modal_Field_EM
 *  \brief A class representing a modal field EM algorithm.
 *  \author Lemine Abdallahi
 *  \date    Aug. 2005

 Applies to an HMRF model. uses mean-field approximations, With a modal field neighborhood restoration.

*/

class Modal_Field_EM : public NREM_Algorithm{
  
public :


  /// Constructor
  Modal_Field_EM(HMRF *mod, Spatial_Data *spatd );  
  /// Constructor
  Modal_Field_EM(HMRF *mod, Spatial_Data *spatd , uint EMiter);  

  /// Destructor
  ~Modal_Field_EM();

  /// Noise restoration step
  void NR();
  
};


#endif
