#define __cplusplus__
#ifndef __NCEMALGO__
#define __NCEMALGO__

#include<iostream>
#include<istream>
#include<fstream>
#include<string>
#include<vector>
#include<sstream>
#include <cmath>



#include <Mixture_Algo.hpp>

using namespace std;


/*! \class NCEM_Algorithm
 *  \brief A class representing an NCEM algorithm.
 *  \author Lemine Abdallahi
 *  \date    Aug. 2005


*/

class NCEM_Algorithm : public Mixture_Algorithm{
  
  /// Penazlization factors
  vector<double> Beta;  
  
public :

  /// Constructor
  NCEM_Algorithm(vector<double> bet, IID_Mixture *mod, Spatial_Data *spatd);  
  /// Constructor
  NCEM_Algorithm(double bet, IID_Mixture *mod, Spatial_Data *spatd);  
  /// Constructor
  NCEM_Algorithm(IID_Mixture *mod, Spatial_Data *spatd);  

  /// Destructor
  ~NCEM_Algorithm();

  /// Set the Penalization factors
  void Set_Beta(vector<double> bet);
	
	/// Compute fuzzy classification for point i 
  void Compute_fuzzy(uint i, vector<double> & probs);  
};


#endif
