#define __cplusplus__
#ifndef __NEMALGO__
#define __NEMALGO__

#include<iostream>
#include<istream>
#include<fstream>
#include<string>
#include<vector>
#include<sstream>
#include <cmath>


#include <Mixture_Algo.hpp>


using namespace std;


/*! \class NEM_Algorithm
 *  \brief A class representing a neighborhood EM algorithm.
 *  \author Lemine Abdallahi
 *  \date    Aug. 2005

 Applies to an IID mixture.

*/

class NEM_Algorithm : public Mixture_Algorithm{

  /// Penazlization factors
  vector<double> Beta;
  

public :

  /// Constructor
  NEM_Algorithm(vector<double> bet, IID_Mixture *mod, Spatial_Data *spatd);  
  /// Constructor
  NEM_Algorithm(double bet, IID_Mixture *mod, Spatial_Data *spatd);  
  /// Constructor
  NEM_Algorithm(IID_Mixture *mod, Spatial_Data *spatd);  

  /// Destructor
  ~NEM_Algorithm();

  /// Set the Penazlization factors
  void Set_Beta(vector<double> bet);

	/// compute fuzzy classifcation for point i
	void Compute_fuzzy(uint i, vector<double> & probs);
};


#endif
