#define __cplusplus__
#ifndef __NREMALGO__
#define __NREMALGO__

#include<iostream>
#include<istream>
#include<fstream>
#include<string>
#include<vector>
#include<sstream>
#include <cmath>

#include <HMRF_Algo.hpp>
#include <Spatial_Data.hpp>

using namespace std;


/*! \class NREM_Algorithm
 *  \brief A class representing a neighborhood restoration EM algorithm.
 *  \author Lemine Abdalli
 *  \date    Aug. 2005

 Applies to an HMRF model. uses mean-field approximations.

*/

class NREM_Algorithm : public HMRF_Algorithm{

protected :
  /// Number of EM iterations at each step.
  uint EM_Iter;
    
public :

  virtual ~NREM_Algorithm();

  /// Noise Restoration step. abstract
  virtual void NR();

  /// Run for a number of iterations ...
  void Run(uint nbiter);
		
	/// fuzzy classification for site i
  void Compute_fuzzy(uint i,vector<double> &probs);  
  
};


#endif
