#define __cplusplus__
#ifndef __SIMFIELDEMALGO__
#define __SIMFIELDEMALGO__

#include<iostream>
#include<istream>
#include<fstream>
#include<string>
#include<vector>
#include<sstream>
#include <cmath>

#include <NREM_Algo.hpp>

using namespace std;


/*! \class Simulated_Field_EM
 *  \brief A class representing a simulated field EM algorithm.
 *  \author Lemine Abdallahi
 *  \date    Aug. 2005

 Applies to an HMRF model. uses mean-field approximations, With a simulated field neighborhood restoration.

*/

class Simulated_Field_EM : public NREM_Algorithm{
    
protected :
  /// Number of Gibbs sampling iterations in the NR step.
  uint NRGibbsIter;

public :

  /// Constructor
  Simulated_Field_EM(HMRF *mod, Spatial_Data *spatd );  
  /// Constructor
  Simulated_Field_EM(HMRF *mod, Spatial_Data *spatd , uint EMiter);  
  /// Constructor
  Simulated_Field_EM(HMRF *mod, Spatial_Data *spatd , uint EMiter, uint NRGibbsit);  

  /// Destructor
  ~Simulated_Field_EM();

  /// Noise restoration step
  void NR();
  
};


#endif
