#include <CEM_Algo.hpp>
#include <Stat.hpp>

CEM_Algorithm::CEM_Algorithm(IID_Mixture *mod, Spatial_Data *spatd){
  Model=mod;
  SpatData=spatd;
  Use_Default_Stopping_Rule();
  uint K=Get_K();
  uint N=Get_N();
  logdens.clear();
	logdens.resize(N*K);
}

CEM_Algorithm::~CEM_Algorithm(){
  
}

void CEM_Algorithm::Compute_fuzzy(uint i,vector<double> &probs){
	uint K=Model->Get_K();
	probs.clear();
	probs.resize(K,0.0);
	double max=-1.0;
	uint kmax;
	vector<double> Pi;
	Model->Get_Pi(Pi);
	
	for(uint k=0 ; k < K ; k++){  
		double curr = Pi[k] * Exp( logdens[i*K+k] - max );
		if (curr>max) {kmax=k;max=curr;}
	}    
	probs[kmax]=1.0;
			
}




