#include <Stat.hpp>
#include <LinAlg.hpp>
#include <Utils.hpp>
#include <Distribution.hpp>


Distribution::~Distribution(){
  
}

void Distribution::Fix(){
	fix=true;
}



void  Distribution::Simulate(vector<double> & X){
	cerr << "Warning! Distribution::Simulate(vector<double> & X) is virtual." << endl;
}

uint Distribution::Get_D(){
  return(Dim);
}

double Distribution::LogDensity(vector<double> const &  X){
  cerr << "Warning! Distribution::LogDensity(vector<double> const & X) is virtual." << endl;
	return(0.0);
}

double Distribution::Density(vector<double> const &  X){
	double logf=LogDensity(X);
	return(Exp(logf));
}

void Distribution::Estimate(Spatial_Data *spatd, vector<double>  const &  freqs){
  cerr << "Warning! Distribution::Estimate(Spatial_Data *spatd, vector<double>  const &  freqs) is virtual." << endl;
}

void Distribution::Read_Params(istream & is){
	cerr << "Warning! Distribution::Read_Params(istream & is) is virtual." << endl;
}

void  Distribution::Write_Params(ostream & os){
	cerr << "Warning! Distribution::Write_Params(istream & is) is virtual." << endl;
}

/// Number of free parameters
uint Distribution::Degrees_Of_Freedom(){
  cerr << "Warning! Distribution::Degrees_Of_Freedom() is virtual." << endl;
	return 0;
}

void Distribution::Info(){
  cerr << "Warning! Distribution::Info() is virtual." << endl;
}
