#include <EM_Algo.hpp>
#include <Stat.hpp>

EM_Algorithm::EM_Algorithm(IID_Mixture *mod, Spatial_Data *spatd){
  Model=mod;
  SpatData=spatd;
  Use_Default_Stopping_Rule();
  uint N=Get_N();
  uint K=Get_K();
  logdens.clear();
	logdens.resize(N*K);

}

EM_Algorithm::~EM_Algorithm(){

}

void EM_Algorithm::Compute_fuzzy(uint i,vector<double> &probs){
	uint K=Model->Get_K();
	probs.clear();
	probs.resize(K);
	double sum=0.0;
	vector<double> Pi;
	Model->Get_Pi(Pi);
	
	double max=0.0;
	for(uint k=0 ; k < K ; k++){  
		if (logdens[i*K+k]>max) max=logdens[i*K+k];
	}
	
	for(uint k=0 ; k < K ; k++){  
		probs[k]=Pi[k] * Exp( logdens[i*K+k] - max );
		sum += probs[k];
	}    
	for(uint k=0 ; k < K ; k++){
		probs[k] /= sum;
	}			
}

