#include <ICM_Algo.hpp>
#include <Stat.hpp>

ICM_Algorithm::ICM_Algorithm(HMRF *mod, Spatial_Data *spatd){
  Model=mod;
  SpatData=spatd;
  Use_Default_Stopping_Rule();
 	uint N=mod->Get_N();
  uint K=mod->Get_K();  
  logdens.clear();
  logdens.resize(N*K);

}

ICM_Algorithm::~ICM_Algorithm(){
  
}

void ICM_Algorithm::Run(uint nbiter){

  for(uint i=0; i< nbiter ; i++) {
		NR();
    E_Step();
    M_Step();
  }
}

void ICM_Algorithm::NR(){
	Model->Set_Zmf(fuzzy);
}

void ICM_Algorithm::Compute_fuzzy(uint i,vector<double> &probs){
	uint K=Model->Get_K();
	probs.clear();
	probs.resize(K);
	double max=-1/0.0;
	uint kmax=0;
	for(uint k=0 ; k < K ; k++){ 
		double loc_energy = Model->Hmf(i,k); 
		double temp=loc_energy + logdens[i*K+k];
		if (temp>max) {kmax=k;max=temp;}
	} 
	for (uint k=0;k<K;k++) probs[k]=0.0;   
	probs[kmax]=1.0;
}

