#include <Modal_Field_EM.hpp>
#include <Stat.hpp>

Modal_Field_EM::Modal_Field_EM(HMRF *mod, Spatial_Data *spatd )  {
  
  Model=mod;
  SpatData=spatd;
  EM_Iter=1; 
  Use_Default_Stopping_Rule();
  
	uint N=mod->Get_N();
  uint K=mod->Get_K();
  logdens.clear();
  logdens.resize(N*K);
}  

Modal_Field_EM::Modal_Field_EM(HMRF *mod, Spatial_Data *spatd , uint EMiter){
  Model=mod;
  SpatData=spatd;
  EM_Iter=EMiter;
  Use_Default_Stopping_Rule();
  
  uint N=mod->Get_N();
  uint K=mod->Get_K();

  logdens.clear();
  logdens.resize(N*K);

}


Modal_Field_EM::~Modal_Field_EM(){
  
}

void Modal_Field_EM::NR(){

  cerr << "Modal_Field_EM::NR()." << endl;

  uint N=Model->Get_N();
  uint K=Model->Get_K();

  vector<double> z(K);

	for(uint i=0; i<N ; i++){
		vector<double> probs;
		Compute_fuzzy(i,probs);

		uint k_mod=argmax(probs);
		for(uint k=0 ; k < K ; k++) z[k]=0;
		z[k_mod]=1;
		Model->Set_Zmf(z,i);
		probs.clear();
	}
  z.clear();
}
