#include <NREM_Algo.hpp>
#include <Utils.hpp>
#include <Stat.hpp>

NREM_Algorithm::~NREM_Algorithm(){
  //  cerr << "NREM_Algorithm::~NREM_Algorithm()." << endl;
}


void NREM_Algorithm::NR(){
  cerr << "NREM_Algorithm::NR() : not defined." << endl;
}

void NREM_Algorithm::Run(uint nbiter){
  //  cerr << "NREM_Algorithm::Run()." << endl;
  for(uint i=0; i< nbiter ; i++) {
    NR();
    for(uint em_i=0; em_i < EM_Iter ; em_i++){
      E_Step();
      Info();
      M_Step();
    }
  }

  //  this->Info();
}

void NREM_Algorithm::Compute_fuzzy(uint i,vector<double> &probs){
	uint K=Get_K();
	probs.clear();
	probs.resize(K);
	double sum=0.0;
	double max=-1.0;
	vector<double> temp(K);
	for(uint k=0 ; k < K ; k++){ 
		double loc_energy = Model->Hmf(i,k); 
		temp[k]=loc_energy + logdens[i*K+k];
		if (temp[k]>max) max=temp[k];
	}
	for (uint k=0 ; k < K ; k++){
		probs[k]=Exp( temp[k]-max );
		sum += probs[k];
	}    
	for(uint k=0 ; k < K ; k++){
		probs[k] /= sum;
	}
	temp.clear();			
}



