#include <Simulated_Field_EM.hpp>
#include <Stat.hpp>
#include <Utils.hpp>



Simulated_Field_EM::Simulated_Field_EM(HMRF *mod, Spatial_Data *spatd )  {
  
  Model=mod;
  SpatData=spatd;
  EM_Iter=1; 
  NRGibbsIter = 10;
  Use_Default_Stopping_Rule();
  uint N=Get_N();
  uint K=Get_K();
  logdens.clear();
	logdens.resize(N*K);
}  

Simulated_Field_EM::Simulated_Field_EM(HMRF *mod, Spatial_Data *spatd , uint EMiter){
  Model=mod;
  SpatData=spatd;
  EM_Iter=EMiter;
  NRGibbsIter = 10;
  Use_Default_Stopping_Rule();
  uint N=Get_N();
  uint K=Get_K();  
  logdens.clear();
	logdens.resize(N*K);
}

Simulated_Field_EM::Simulated_Field_EM(HMRF *mod, Spatial_Data *spatd , uint EMiter, uint NRGibbsit ){
  Model=mod;
  SpatData=spatd;
  EM_Iter=EMiter;
  NRGibbsIter = NRGibbsit ;
  Use_Default_Stopping_Rule();
  uint N=Get_N();
  uint K=Get_K();
  logdens.clear();
	logdens.resize(N*K);
}



Simulated_Field_EM::~Simulated_Field_EM(){
  
}


void Simulated_Field_EM::NR(){
  
  cerr << "Simulated_Field_EM::NR(). " << endl;
  uint N=Model->Get_N();
  uint K=Model->Get_K();
  

  vector<double> z(K);

  for(uint it=0;it<NRGibbsIter;it++){
    for(uint i=0; i<N ; i++){
    
			vector<double> probs(K);
			Compute_fuzzy(i,probs);
  
      uint k_sim=Sample(probs);
      for(uint k=0 ; k < K ; k++) z[k]=0;
      z[k_sim]=1;
      Model->Set_Zmf(z,i);
      
      probs.clear();
    }    
  }
  Info();

  z.clear();
	
}
